Attribute VB_Name = "modGauss"
'
'    Copyright (C) 2008  Colin Caprani - www.colincaprani.com
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit

Sub modGaussElim(gstiff() As Double, defl() As Double, force() As Double, n As Integer)
Dim tmc As Double, irow As Integer, icol As Integer
Dim k As Integer, np As Integer, bg As Double
Dim te As Double
Dim j As Integer, i As Integer, r As Integer

ReDim Preserve gstiff(n, n + 1)

For irow = 1 To n
    gstiff(irow, n + 1) = force(irow)
Next irow

For k = 1 To n - 1
        np = k
        bg = Abs(gstiff(k, k))
    
        For j = k + 1 To n
            If Abs(gstiff(j, k)) > bg Then
                bg = Abs(gstiff(j, k))
                np = j
            End If
        Next j
    
        If np = k Then
            Call exRows(gstiff(), k, n)
        Else
            For i = k To n + 1
                te = gstiff(k, i)
                gstiff(k, i) = gstiff(np, i)
                gstiff(np, i) = te
            Next i
            Call exRows(gstiff(), k, n)
        End If
Next k

Call backsub(gstiff(), n)

For r = 1 To n
    defl(r) = gstiff(r, n + 1)
Next r

End Sub

Function exRows(gstiff() As Double, k As Integer, n As Integer)
Dim j As Integer, q As Integer
Dim fc As Double

For j = k + 1 To n
    If gstiff(k, k) = 0 Then
        Call errorFunc
        Exit Function
    Else:
        fc = gstiff(j, k) / gstiff(k, k)
        For q = k + 1 To n + 1
            gstiff(j, q) = gstiff(j, q) - fc * gstiff(k, q)
        Next q
    End If
Next j
End Function

Function backsub(gstiff() As Double, n As Integer)
Dim i As Integer, j As Integer
Dim sum As Double

gstiff(n, n + 1) = gstiff(n, n + 1) / gstiff(n, n)

For i = n - 1 To 1 Step -1
    sum = 0
    For j = i + 1 To n
        sum = sum + gstiff(i, j) * gstiff(j, n + 1)
    Next j
    gstiff(i, n + 1) = (gstiff(i, n + 1) - sum) / gstiff(i, i)
Next i

End Function

Function errorFunc()
MsgBox "Aborting analysis", vbCritical, "Gauss Elimination Error"
End Function






